<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';


use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['visitor_log_id']) or !checkIfIssetAndNotEmpty($postdata['visitor_log_id']) or
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or 
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$namee = $jwt_validate->data->name;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

// $institution_id = trim($postdata['institution_id']);
$visitorid = trim($postdata['visitor_log_id']);

//Specific Db Connection
$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], $institution_id);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

//Validate institution_id and branch_id
$academicSessionId = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if (!$academicSessionId) {
    errorreturn("Invalid institution_id");
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning,$conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

function getspecific_visitor($conn_rjllearning_specific, $institution_id,$branch_id,$visitorid)
{
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM visitors_log WHERE id = ? AND institution_id = ? AND branch_id = ?");
    $sql->execute(array($visitorid, $institution_id,$branch_id));
    $result = $sql->fetchAll();

    $array_retrurn = array();
    if (count($result) == 1) {
        foreach ($result as $res) {

            if ($res['proof_document'] != null and !is_array($res['proof_document'])) {
                $data_attachment = json_decode($res['proof_document'], true);
                $filePath = $data_attachment['filepath'];
                $originalName = $data_attachment['original_name'];
                $aws_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
                $final_array_attachment   = array("filepath" => $aws_attachment, "original_name" => $originalName);
            } else {
                $final_array_attachment =  null;
            }
            
            $visitor_info = array(
                // "visitor_log_id" => $res['id'],
                "name" => $res['name'],
                "organisationname" => $res['organisationname'],
                "date" => $res['date'],
                "purpose" => $res['purpose'],
                "remarksby_authoriser" => $res['remarksby_authoriser'],
                "proof_document" => $final_array_attachment
            );
            if (!empty($res['student_id'])) {
                $visitor_info['student_id'] = $res['student_id'];
            }
            $array_return[] = $visitor_info;
        }
        return $array_return;
    } else {
        errorreturn("Visitor info not found");
    }
}

if ($postdata['function_type'] == "fetch_specific_visitor") {
    $visitorid = trim($postdata['visitor_log_id']);
    $visitor_data = getspecific_visitor($conn_rjllearning_specific, $institution_id,$branch_id, $visitorid);
    successreturn(['data' => $visitor_data]);
}
